package org.eclipse.jdt.internal.compiler.lookup;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.eclipse.jdt.internal.compiler.lookup.LookupEnvironment;
import org.eclipse.jdt.internal.compiler.lookup.MethodBinding;
import org.eclipse.jdt.internal.compiler.lookup.ParameterizedMethodBinding;
import org.eclipse.jdt.internal.compiler.lookup.ParameterizedTypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.ProblemMethodBinding;
import org.eclipse.jdt.internal.compiler.lookup.ReferenceBinding;
import org.eclipse.jdt.internal.compiler.lookup.TypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.TypeConstants;

public class SyntheticFactoryMethodBinding extends MethodBinding {
  private MethodBinding staticFactoryFor;
  
  private LookupEnvironment environment;
  
  private ReferenceBinding enclosingType;
  
  public SyntheticFactoryMethodBinding(MethodBinding method, LookupEnvironment environment, ReferenceBinding enclosingType) {
    super(method.modifiers | 0x8, TypeConstants.SYNTHETIC_STATIC_FACTORY, null, null, null, method.declaringClass);
    this.environment = environment;
    this.staticFactoryFor = method;
    this.enclosingType = enclosingType;
  }
  
  public MethodBinding getConstructor() {
    return this.staticFactoryFor;
  }
  
  public ParameterizedMethodBinding applyTypeArgumentsOnConstructor(TypeBinding[] typeArguments, TypeBinding[] constructorTypeArguments, boolean inferredWithUncheckedConversion) {
    ParameterizedTypeBinding parameterizedTypeBinding = this.environment.createParameterizedType(this.declaringClass, typeArguments, 
        this.enclosingType);
    byte b;
    int i;
    MethodBinding[] arrayOfMethodBinding;
    for (i = (arrayOfMethodBinding = parameterizedTypeBinding.methods()).length, b = 0; b < i; ) {
      MethodBinding parameterizedMethod = arrayOfMethodBinding[b];
      if (parameterizedMethod.original() == this.staticFactoryFor)
        return (constructorTypeArguments.length > 0 || inferredWithUncheckedConversion) ? 
          (ParameterizedMethodBinding)this.environment.createParameterizedGenericMethod(parameterizedMethod, constructorTypeArguments, inferredWithUncheckedConversion, false) : 
          (ParameterizedMethodBinding)parameterizedMethod; 
      if (parameterizedMethod instanceof ProblemMethodBinding) {
        MethodBinding closestMatch = ((ProblemMethodBinding)parameterizedMethod).closestMatch;
        if (closestMatch instanceof ParameterizedMethodBinding && closestMatch.original() == this.staticFactoryFor)
          return (ParameterizedMethodBinding)closestMatch; 
      } 
      b++;
    } 
    throw new IllegalArgumentException("Type doesn't have its own method?");
  }
}
